!INCLUDE ..\Makefile.VS.common

OUTDIR = ..\..\lib

YAMI_LIB = $(OUTDIR)\yamicore.lib

CPP = cl.exe
CPP_OPTIONS = /c /nologo /EHsc /MD /O2 /D _CRT_SECURE_NO_WARNINGS /I ..\..\include /I windows $(OPEN_SSL_OPTIONS)

ARCHIVE = lib.exe
ARCHIVE_FLAGS = /nologo /out:$(YAMI_LIB)

ARCHIVE_OBJS = \
	agent.obj \
	allocator.obj \
	c_interface.obj \
	channel.obj \
	channel_group.obj \
	channel_holder.obj \
	fatal_errors.obj \
	listener.obj \
	network_utils.obj \
	options.obj \
	parameter_entry.obj \
	parameter_iterator.obj \
	parameters-details.obj \
	parameters.obj \
	raw_buffer_data_source.obj \
	serialization.obj \
	windows\win_channel.obj \
	windows\io_error_handler.obj \
	windows\win_listener.obj \
	windows\mutex.obj \
	windows\win_network_utils.obj \
	windows\selector.obj

all : platform_objects $(YAMI_LIB)

platform_objects :
	cd windows
	nmake /F Makefile.VS
	cd ..

$(YAMI_LIB) : $(ARCHIVE_OBJS)
	$(ARCHIVE) $(ARCHIVE_FLAGS) $(ARCHIVE_OBJS)

.cpp.obj::
	$(CPP) $(CPP_OPTIONS) $< 

clean :
	cd windows
	nmake /F Makefile.VS clean
	cd ..
	del /Q *.obj
	del /Q $(YAMI_LIB)
