// Copyright Maciej Sobczak 2008-2020.
// This file is part of YAMI4.
//
// YAMI4 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// YAMI4 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.

#ifndef YAMICORE_DETAILS_TYPES_H_INCLUDED
#define YAMICORE_DETAILS_TYPES_H_INCLUDED

#include <FreeRTOS.h>
#include <event_groups.h>
#include <lwip/ip_addr.h>
#include <lwip/tcp.h>
#include <lwip/udp.h>

namespace yami
{

namespace details
{

typedef union
{
    struct udp_pcb * udp;
    struct tcp_pcb * tcp;
} io_descriptor_type;

const io_descriptor_type empty_io_descriptor = { NULL };

typedef ip_addr_t host_type;
typedef u16_t port_type; // host byte order

const ip_addr_t ip_any_address = ip_addr_any;

const EventBits_t selector_interrupt_event = 1ul;
const EventBits_t listener_event = 2ul;
const EventBits_t channel_input_event = 4ul;
const EventBits_t channel_output_event = 8ul;

} // namespace details

} // namespace yami

#endif // YAMICORE_DETAILS_TYPES_H_INCLUDED
