!INCLUDE ..\Makefile.VS.common

OUTDIR = ..\..\lib
PUBLIC_HEADERS_DIR = ..\..\include\yami4-cpp

YAMI_LIB = $(OUTDIR)\yamicpp.lib

CPP = cl.exe
CPP_OPTIONS = /c /nologo /EHsc /MD /O2 /D _CRT_SECURE_NO_WARNINGS \
	/I ..\..\include /I windows /I ..\core\windows $(OPEN_SSL_OPTIONS)

ARCHIVE = lib.exe
ARCHIVE_FLAGS = /nologo /out:$(YAMI_LIB)

ARCHIVE_OBJS = \
	activity_statistics_monitor.obj \
	agent.obj \
	agent_impl.obj \
	details.obj \
	id_generator.obj \
	incoming_message.obj \
	incoming_message_queue.obj \
	name_resolver.obj \
	options.obj \
	outgoing_message.obj \
	outgoing_message_info.obj \
	outgoing_message_manager.obj \
	parameter_entry.obj \
	parameters.obj \
	raw_buffer_data_source.obj \
	value_publisher.obj \
	value_publisher_impl.obj \
	version.obj \
	water_flow_manager.obj \
	windows\delay.obj \
	windows\flag.obj \
	windows\semaphore.obj \
	windows\start_thread.obj

all : platform_objects $(YAMI_LIB)

platform_objects :
	cd windows
	nmake /F Makefile.VS
	cd ..

$(YAMI_LIB) : $(ARCHIVE_OBJS)
	$(ARCHIVE) $(ARCHIVE_FLAGS) $(ARCHIVE_OBJS)

.cpp.obj::
	$(CPP) $(CPP_OPTIONS) $< 

clean :
	cd windows
	nmake /F Makefile.VS clean
	cd ..
	del /Q *.obj
	del /Q $(YAMI_LIB)
