// Copyright Maciej Sobczak 2008-2020.
// This file is part of YAMI4.
//
// YAMI4 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// YAMI4 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.

#include "semaphore.h"

#include <ti/sysbios/BIOS.h>

using namespace yami;
using namespace details;

details::semaphore::semaphore()
{
    Semaphore_construct(&sem_, 0, NULL);
}

details::semaphore::~semaphore()
{
    Semaphore_destruct(&sem_);
}

void details::semaphore::release()
{
    Semaphore_post(Semaphore_handle(&sem_));
}

void details::semaphore::acquire()
{
    Semaphore_pend(Semaphore_handle(&sem_), BIOS_WAIT_FOREVER);
}
