// Copyright Maciej Sobczak 2019-2020.
// This file is part of YAMI4.
//
// YAMI4 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// YAMI4 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.

#ifndef YAMI4GATEWAY_UTILS_H
#define YAMI4GATEWAY_UTILS_H

#include <string>
#include <vector>

namespace utils
{

std::string new_key();

std::vector<std::string> tokenize(const std::string & str);

std::string format(const std::string & str);

std::string catenate(const std::vector<std::string> & tokens);

std::vector<unsigned char> to_binary(const std::string & str);

std::string from_binary(const void * data, std::size_t size);

} // namespace utils

#endif // YAMI4GATEWAY_UTILS_H
