(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5780,        149]
NotebookOptionsPosition[      4266,        121]
NotebookOutlinePosition[      4601,        136]
CellTagsIndexPosition[      4558,        133]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Calculator example client", "Section",
 CellChangeTimes->{{3.7638896154806557`*^9, 3.763889619447788*^9}, {
  3.764041219102935*^9, 
  3.7640412204936438`*^9}},ExpressionUUID->"d045fc4e-645c-4f31-b2ef-\
66c283b66c88"],

Cell["Load the package and initialize gateway\[CloseCurlyQuote]s agent:", \
"Text",
 CellChangeTimes->{{3.7638896273099337`*^9, 
  3.7638896440402393`*^9}},ExpressionUUID->"0ba87031-1a2e-4a58-b111-\
84428486e8d0"],

Cell[BoxData[
 RowBox[{"<<", "YAMI4`"}]], "Input",
 CellChangeTimes->{{3.763889538186205*^9, 3.763889540611994*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"1acd17d6-c15f-45d1-b178-f5fbd0ee1b0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"yami", "=", 
   RowBox[{"openGateway", "[", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.763889650325575*^9, 3.7638897159148507`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"459878ec-0dc6-4217-9947-44f7cab93dae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"init", "[", "yami", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.7638897021500816`*^9, 3.763889719053357*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"60da9a2c-9e24-4fea-b8ec-f939803532d3"],

Cell["\<\
Assuming the appropriate server is already started, send a message to the \
calculator server:\
\>", "Text",
 CellChangeTimes->{{3.7638897309077215`*^9, 3.7638897534296675`*^9}, {
  3.7638958613355103`*^9, 3.763895879256915*^9}, {3.7640412279435062`*^9, 
  3.7640412454305305`*^9}},ExpressionUUID->"ba0ca99e-abd0-492f-b7f9-\
c15ec2b00e8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"msg", "=", 
   RowBox[{"send", "[", 
    RowBox[{
    "yami", ",", "\"\<tcp://127.0.0.1:12345\>\"", ",", "\"\<calculator\>\"", 
     ",", "\"\<calculate\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{"<|", 
      RowBox[{
       RowBox[{"a", "\[Rule]", "100"}], ",", 
       RowBox[{"b", "\[Rule]", "4"}]}], "|>"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7638897547601485`*^9, 3.763889805514244*^9}, {
   3.764041248879287*^9, 3.7640412688786106`*^9}, 3.7640413111108303`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"8922e56a-7a98-461e-8dbc-47c076e147bc"],

Cell["\<\
Check message state (it might be posted, transmitted, abandoned, replied or \
rejected):\
\>", "Text",
 CellChangeTimes->{{3.7640413419370217`*^9, 3.764041348784565*^9}, {
  3.7640413957114477`*^9, 
  3.764041419561821*^9}},ExpressionUUID->"f799bfc4-5d9f-4c8a-947a-\
1f1eeff085aa"],

Cell[BoxData[
 RowBox[{"state", "[", "msg", "]"}]], "Input",
 CellChangeTimes->{{3.7640413515198727`*^9, 3.764041354022622*^9}, {
  3.764041390864011*^9, 3.764041391478649*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"d74f3461-bcd5-42c8-9d28-278d4d96f3b6"],

Cell["Get the results:", "Text",
 CellChangeTimes->{{3.7640414259388237`*^9, 
  3.7640414361607156`*^9}},ExpressionUUID->"52aa5d61-c263-4bdc-bcc2-\
99dce6eb6abf"],

Cell[BoxData[
 RowBox[{"response", "[", "msg", "]"}]], "Input",
 CellChangeTimes->{{3.7640414389863462`*^9, 3.7640414411096168`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"6a55f04e-3a45-4a7a-a957-f514c4924c89"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.7640415478837843`*^9, 
  3.764041548104392*^9}},ExpressionUUID->"b0405d4f-967e-44ac-9665-\
735aa60e37b2"],

Cell["\<\
For long-term operation with large number of messages, it is recommended to \
clean them:\
\>", "Text",
 CellChangeTimes->{{3.7640415704995975`*^9, 
  3.7640415938595643`*^9}},ExpressionUUID->"6733dd43-1537-4aaf-9d65-\
5a2b8421d9cb"],

Cell[BoxData[
 RowBox[{"close", "[", "msg", "]"}]], "Input",
 CellChangeTimes->{{3.764041594852245*^9, 3.7640415967806854`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"da17ac13-65fb-4fce-beed-007ee01bb00e"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 223, 4, 67, "Section",ExpressionUUID->"d045fc4e-645c-4f31-b2ef-66c283b66c88"],
Cell[806, 28, 213, 4, 35, "Text",ExpressionUUID->"0ba87031-1a2e-4a58-b111-84428486e8d0"],
Cell[1022, 34, 194, 3, 30, "Input",ExpressionUUID->"1acd17d6-c15f-45d1-b178-f5fbd0ee1b0b"],
Cell[1219, 39, 250, 5, 30, "Input",ExpressionUUID->"459878ec-0dc6-4217-9947-44f7cab93dae"],
Cell[1472, 46, 224, 4, 30, "Input",ExpressionUUID->"60da9a2c-9e24-4fea-b8ec-f939803532d3"],
Cell[1699, 52, 349, 7, 35, "Text",ExpressionUUID->"ba0ca99e-abd0-492f-b7f9-c15ec2b00e8e"],
Cell[2051, 61, 601, 13, 52, "Input",ExpressionUUID->"8922e56a-7a98-461e-8dbc-47c076e147bc"],
Cell[2655, 76, 291, 7, 35, "Text",ExpressionUUID->"f799bfc4-5d9f-4c8a-947a-1f1eeff085aa"],
Cell[2949, 85, 255, 4, 30, "Input",ExpressionUUID->"d74f3461-bcd5-42c8-9d28-278d4d96f3b6"],
Cell[3207, 91, 162, 3, 35, "Text",ExpressionUUID->"52aa5d61-c263-4bdc-bcc2-99dce6eb6abf"],
Cell[3372, 96, 211, 3, 30, "Input",ExpressionUUID->"6a55f04e-3a45-4a7a-a957-f514c4924c89"],
Cell[3586, 101, 208, 4, 73, "Input",ExpressionUUID->"b0405d4f-967e-44ac-9665-735aa60e37b2"],
Cell[3797, 107, 243, 6, 35, "Text",ExpressionUUID->"6733dd43-1537-4aaf-9d65-5a2b8421d9cb"],
Cell[4043, 115, 207, 3, 30, "Input",ExpressionUUID->"da17ac13-65fb-4fce-beed-007ee01bb00e"]
}, Open  ]]
}
]
*)

