(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7559,        184]
NotebookOptionsPosition[      5658,        151]
NotebookOutlinePosition[      6012,        167]
CellTagsIndexPosition[      5969,        164]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Print example server", "Section",
 CellChangeTimes->{{3.7638896154806557`*^9, 3.763889619447788*^9}, {
  3.7638959194177866`*^9, 
  3.7638959200331616`*^9}},ExpressionUUID->"4fb2e690-5baf-4e37-8a89-\
64bad412761f"],

Cell["Load the package and initialize gateway\[CloseCurlyQuote]s agent:", \
"Text",
 CellChangeTimes->{{3.7638896273099337`*^9, 
  3.7638896440402393`*^9}},ExpressionUUID->"31e607d5-4ff5-485d-b71a-\
59df4d57fe91"],

Cell[BoxData[
 RowBox[{"<<", "YAMI4`"}]], "Input",
 CellChangeTimes->{{3.763889538186205*^9, 3.763889540611994*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"a9ce90a6-cc37-443a-a1e9-8e1337c8a9a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"yami", "=", 
   RowBox[{"openGateway", "[", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.763889650325575*^9, 3.7638897159148507`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"7a649b07-c0a6-4ad3-a348-4d670e7cec21"],

Cell[BoxData[
 RowBox[{"init", "[", "yami", "]"}]], "Input",
 CellChangeTimes->{{3.7638897021500816`*^9, 3.763889719053357*^9}, 
   3.7638960502608905`*^9},
 CellLabel->"In[3]:=",ExpressionUUID->"d7d4d93e-9d9f-4f3f-80ab-08c1f4f4c2e7"],

Cell["Set up the listener on the port that is known to clients:", "Text",
 CellChangeTimes->{{3.763896203731151*^9, 
  3.763896251685005*^9}},ExpressionUUID->"917c1601-8a6a-4a63-aad3-\
a5fb54312a6f"],

Cell[BoxData[
 RowBox[{"addListener", "[", 
  RowBox[{"yami", ",", "\"\<tcp://127.0.0.1:12345\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.763896224944483*^9, 3.7638962347883053`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"7aa36687-16cd-4a0b-bf8f-c71cf7b5e1c2"],

Cell["Register a receiver object with appropriate name:", "Text",
 CellChangeTimes->{{3.7638959272127857`*^9, 
  3.7638959527288103`*^9}},ExpressionUUID->"f55a1e42-976f-42ad-83ee-\
5536841c9c91"],

Cell[BoxData[
 RowBox[{"registerObject", "[", 
  RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.763896020224881*^9, 3.763896026110896*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"c5e987a3-21b5-4477-a697-d738b3b43060"],

Cell["Wait for some client to send its request:", "Text",
 CellChangeTimes->{{3.7638960688622527`*^9, 
  3.7638960828580008`*^9}},ExpressionUUID->"054cb2af-45d2-418d-bde6-\
eceda5f1f63d"],

Cell[BoxData[
 RowBox[{"waitForIncoming", "[", 
  RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.763896060886646*^9, 3.7638960661618967`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"f3e597da-a9f5-4cfb-a93a-4f864c9322ba"],

Cell["See the parameters of the last request:", "Text",
 CellChangeTimes->{{3.7638897309077215`*^9, 3.7638897534296675`*^9}, {
  3.7638958613355103`*^9, 3.763895879256915*^9}, {3.763896284315353*^9, 
  3.7638962931623793`*^9}},ExpressionUUID->"078764d7-8f09-4127-b051-\
d07b8bc0f504"],

Cell[BoxData[
 RowBox[{"requestParams", "[", 
  RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.763896295845724*^9, 3.7638963042617874`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"c5277f4e-199a-44c7-a6cc-411984f854d2"],

Cell["\<\
If there is no further action on this message expected (like reply or \
reject), it should be explicitly \[OpenCurlyDoubleQuote]consumed\
\[CloseCurlyDoubleQuote] so that further messages can take its place:\
\>", "Text",
 CellChangeTimes->{{3.763897063320341*^9, 
  3.763897132215483*^9}},ExpressionUUID->"60181d44-aba5-4710-8821-\
da165b063807"],

Cell[BoxData[
 RowBox[{"consume", "[", 
  RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.7638971336763697`*^9, 3.76389713851127*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"8415fe70-0e7e-4fdf-8adc-e5f222168189"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.763896351775878*^9, 
  3.7638963556190176`*^9}},ExpressionUUID->"34c30128-51ec-44e5-b700-\
ef79bf46d4c9"],

Cell["\<\
For continuous server operation, the last three operations are usually run in \
a loop:\
\>", "Text",
 CellChangeTimes->{{3.7638963579665256`*^9, 3.7638963847567663`*^9}, {
  3.7638971513924894`*^9, 
  3.763897153177272*^9}},ExpressionUUID->"89114256-5854-490d-a4e4-\
c0626a694432"],

Cell[BoxData[
 RowBox[{"While", "[", 
  RowBox[{"True", ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"waitForIncoming", "[", 
     RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"p", "=", 
     RowBox[{"requestParams", "[", 
      RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"consume", "[", 
     RowBox[{"yami", ",", "\"\<printer\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"content", "=", 
     RowBox[{"p", "[", "\"\<content\>\"", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", "content", "]"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.763896386142542*^9, 3.763896391875063*^9}, {
   3.763897157827637*^9, 3.763897206872713*^9}, 
   3.7638973161335664`*^9},ExpressionUUID->"80c7bee9-47bf-4fba-8a15-\
aac0b7b374c6"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{28, Automatic}, {60, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 220, 4, 67, "Section",ExpressionUUID->"4fb2e690-5baf-4e37-8a89-64bad412761f"],
Cell[803, 28, 213, 4, 35, "Text",ExpressionUUID->"31e607d5-4ff5-485d-b71a-59df4d57fe91"],
Cell[1019, 34, 194, 3, 30, "Input",ExpressionUUID->"a9ce90a6-cc37-443a-a1e9-8e1337c8a9a1"],
Cell[1216, 39, 250, 5, 30, "Input",ExpressionUUID->"7a649b07-c0a6-4ad3-a348-4d670e7cec21"],
Cell[1469, 46, 234, 4, 30, "Input",ExpressionUUID->"d7d4d93e-9d9f-4f3f-80ab-08c1f4f4c2e7"],
Cell[1706, 52, 199, 3, 35, "Text",ExpressionUUID->"917c1601-8a6a-4a63-aad3-a5fb54312a6f"],
Cell[1908, 57, 264, 4, 30, "Input",ExpressionUUID->"7aa36687-16cd-4a0b-bf8f-c71cf7b5e1c2"],
Cell[2175, 63, 195, 3, 35, "Text",ExpressionUUID->"f55a1e42-976f-42ad-83ee-5536841c9c91"],
Cell[2373, 68, 251, 4, 30, "Input",ExpressionUUID->"c5e987a3-21b5-4477-a697-d738b3b43060"],
Cell[2627, 74, 187, 3, 35, "Text",ExpressionUUID->"054cb2af-45d2-418d-bde6-eceda5f1f63d"],
Cell[2817, 79, 254, 4, 30, "Input",ExpressionUUID->"f3e597da-a9f5-4cfb-a93a-4f864c9322ba"],
Cell[3074, 85, 284, 4, 35, "Text",ExpressionUUID->"078764d7-8f09-4127-b051-d07b8bc0f504"],
Cell[3361, 91, 252, 4, 30, "Input",ExpressionUUID->"c5277f4e-199a-44c7-a6cc-411984f854d2"],
Cell[3616, 97, 357, 7, 58, "Text",ExpressionUUID->"60181d44-aba5-4710-8821-da165b063807"],
Cell[3976, 106, 245, 4, 30, "Input",ExpressionUUID->"8415fe70-0e7e-4fdf-8adc-e5f222168189"],
Cell[4224, 112, 208, 4, 73, "Input",ExpressionUUID->"34c30128-51ec-44e5-b700-ef79bf46d4c9"],
Cell[4435, 118, 292, 7, 35, "Text",ExpressionUUID->"89114256-5854-490d-a4e4-c0626a694432"],
Cell[4730, 127, 912, 21, 178, "Input",ExpressionUUID->"80c7bee9-47bf-4fba-8a15-aac0b7b374c6"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

