(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6320,        158]
NotebookOptionsPosition[      4969,        131]
NotebookOutlinePosition[      5323,        147]
CellTagsIndexPosition[      5280,        144]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Subscriber example", "Section",
 CellChangeTimes->{{3.7638896154806557`*^9, 3.763889619447788*^9}, {
  3.7638959194177866`*^9, 3.7638959200331616`*^9}, {3.764041686182237*^9, 
  3.7640416886808925`*^9}, {3.7640428758655586`*^9, 
  3.7640428795985827`*^9}},ExpressionUUID->"eb5b5708-d9ee-4328-b814-\
7b74eb37c645"],

Cell["Load the package and initialize gateway\[CloseCurlyQuote]s agent:", \
"Text",
 CellChangeTimes->{{3.7638896273099337`*^9, 
  3.7638896440402393`*^9}},ExpressionUUID->"c7850280-35fe-4afa-a13c-\
282357bb5b3a"],

Cell[BoxData[
 RowBox[{"<<", "YAMI4`"}]], "Input",
 CellChangeTimes->{{3.763889538186205*^9, 3.763889540611994*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"21f2f279-a5be-41c1-b47d-43dcd2b4a58d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"yami", "=", 
   RowBox[{"openGateway", "[", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.763889650325575*^9, 3.7638897159148507`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"2c461cdc-ea4c-4c66-a2a0-5e0e1053731c"],

Cell[BoxData[
 RowBox[{"init", "[", "yami", "]"}]], "Input",
 CellChangeTimes->{{3.7638897021500816`*^9, 3.763889719053357*^9}, 
   3.7638960502608905`*^9},
 CellLabel->"In[3]:=",ExpressionUUID->"48edd5d3-8feb-429e-9069-ba6da37c8379"],

Cell["Register an object that will be used to receive updates:", "Text",
 CellChangeTimes->{{3.7638959272127857`*^9, 3.7638959527288103`*^9}, {
  3.7640429387034674`*^9, 
  3.7640429473675127`*^9}},ExpressionUUID->"3ae502d7-10c7-4c6e-ab5a-\
feeb68980ff6"],

Cell[BoxData[
 RowBox[{"registerObject", "[", 
  RowBox[{"yami", ",", "\"\<update_handler\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.763896020224881*^9, 3.763896026110896*^9}, {
  3.7640420400786705`*^9, 3.7640420429894123`*^9}, {3.7640429496722493`*^9, 
  3.764042953167616*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"aa1d908a-e6f7-4b19-84d2-b81b7178d5fc"],

Cell["\<\
Send the subscription request to the publisher (assuming the publisher is \
already up and running):\
\>", "Text",
 CellChangeTimes->{{3.7640429688899*^9, 
  3.7640429832641864`*^9}},ExpressionUUID->"11646384-87d5-44b4-975e-\
1be16e2c535c"],

Cell[BoxData[
 RowBox[{"sendOneWay", "[", 
  RowBox[{
  "yami", ",", "\"\<tcp://127.0.0.1:12345\>\"", ",", "\"\<random_number\>\"", 
   ",", "\"\<subscribe\>\"", ",", 
   RowBox[{"<|", 
    RowBox[{
    "\"\<destination_object\>\"", "\[Rule]", "\"\<update_handler\>\""}], 
    "|>"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.764042984443346*^9, 3.764043032993847*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"8babbe21-063b-4500-b88c-77766c388414"],

Cell["\<\
Wait in a loop to receive updates, using the idiom as for a regular server:\
\>", "Text",
 CellChangeTimes->{{3.7638960688622527`*^9, 3.7638960828580008`*^9}, {
  3.7640430439152365`*^9, 
  3.7640431023390555`*^9}},ExpressionUUID->"9568afa4-0844-433c-93f2-\
0c15a9c804f4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dataPoints", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dynamic", "[", 
  RowBox[{"ListLinePlot", "[", "dataPoints", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.764043260784582*^9, 3.7640432621602573`*^9}, {
  3.764043309691489*^9, 3.7640433302214556`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"36c62964-a52e-4a96-ac97-321ff044fa5d"],

Cell[BoxData[
 RowBox[{"While", "[", 
  RowBox[{"True", ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"waitForIncoming", "[", 
     RowBox[{"yami", ",", "\"\<update_handler\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"params", "=", 
     RowBox[{"requestParams", "[", 
      RowBox[{"yami", ",", "\"\<update_handler\>\""}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"AppendTo", "[", 
     RowBox[{"dataPoints", ",", 
      RowBox[{"params", "[", "\"\<value\>\"", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"consume", "[", 
     RowBox[{"yami", ",", "\"\<update_handler\>\""}], "]"}], ";"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.763896060886646*^9, 3.7638960661618967`*^9}, {
  3.76404204929626*^9, 3.7640420536197844`*^9}, {3.7640430556807575`*^9, 
  3.7640430700064383`*^9}, {3.764043105098363*^9, 3.764043179429535*^9}, {
  3.764043333887413*^9, 3.7640433419749155`*^9}, {3.76404374415117*^9, 
  3.764043785764868*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"0aa1ed36-6d24-4dba-8b0d-98e08ba9b564"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{36, Automatic}, {40, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 319, 5, 67, "Section",ExpressionUUID->"eb5b5708-d9ee-4328-b814-7b74eb37c645"],
Cell[902, 29, 213, 4, 35, "Text",ExpressionUUID->"c7850280-35fe-4afa-a13c-282357bb5b3a"],
Cell[1118, 35, 194, 3, 30, "Input",ExpressionUUID->"21f2f279-a5be-41c1-b47d-43dcd2b4a58d"],
Cell[1315, 40, 250, 5, 30, "Input",ExpressionUUID->"2c461cdc-ea4c-4c66-a2a0-5e0e1053731c"],
Cell[1568, 47, 234, 4, 30, "Input",ExpressionUUID->"48edd5d3-8feb-429e-9069-ba6da37c8379"],
Cell[1805, 53, 255, 4, 35, "Text",ExpressionUUID->"3ae502d7-10c7-4c6e-ab5a-feeb68980ff6"],
Cell[2063, 59, 362, 6, 30, "Input",ExpressionUUID->"aa1d908a-e6f7-4b19-84d2-b81b7178d5fc"],
Cell[2428, 67, 250, 6, 35, "Text",ExpressionUUID->"11646384-87d5-44b4-975e-1be16e2c535c"],
Cell[2681, 75, 447, 10, 52, "Input",ExpressionUUID->"8babbe21-063b-4500-b88c-77766c388414"],
Cell[3131, 87, 282, 6, 35, "Text",ExpressionUUID->"9568afa4-0844-433c-93f2-0c15a9c804f4"],
Cell[3416, 95, 403, 8, 52, "Input",ExpressionUUID->"36c62964-a52e-4a96-ac97-321ff044fa5d"],
Cell[3822, 105, 1131, 23, 178, "Input",ExpressionUUID->"0aa1ed36-6d24-4dba-8b0d-98e08ba9b564"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

